﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.geom.Rectangle;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	import flash.text.TextFieldType;
	import flash.text.TextFormatAlign;
	public class Graphing extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var dragObj:MovieClip=new MovieClip();
		
		private var Col1Array:Array=new Array();
		private var Col2Array:Array=new Array();
		private var counter:Number=0;
		private var noOfBoxes:Number = 0;
		
		public function Graphing()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO_F51.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			AddBGFrame();
			DrawLines();
			AddInputText();
			
			CreateText();
			var mc:MovieClip=CreateDraggableItem();
			addChild(mc);
			mc.addEventListener(MouseEvent.MOUSE_DOWN,dragDuplicate);
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
		}		
		private function onReset(eve:MouseEvent=null):void{
			for(var i:int=0;i<Col1Array.length;i++)
			{
				removeChild(Col1Array[i])
				
			}
			for(i=0;i<Col2Array.length;i++)
			{
				removeChild(Col2Array[i])
			}
			Col1Array = new Array();
			Col2Array = new Array();
		}
		private function dragDuplicate(e:MouseEvent):void
		{
			var mc:MovieClip=CreateDraggableItem();
			addChild(mc);
			dragObj=mc;
			setChildIndex(mc,numChildren-1);
			mc.startDrag(false,new Rectangle(0,0,760-mc.width,530-mc.height));
			mc.addEventListener(MouseEvent.MOUSE_DOWN,dragthis);
			mc.addEventListener(MouseEvent.MOUSE_UP,dropthis);
			stage.addEventListener(MouseEvent.MOUSE_UP,dropthis);
			CheckDuplicate();
			var ltop=getChildByName("Line_0");
			var lbtm=getChildByName("Line_2");
			var spaceBtnLines:Number = lbtm.y - ltop.y;
			noOfBoxes = int(spaceBtnLines/mc.height);	
		}
		private function dragthis(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			dragObj=tar;
			setChildIndex(tar,numChildren-1);
			tar.startDrag(false,new Rectangle(0,0,stage.stageWidth-tar.width,stage.stageHeight-tar.height));
			tar.addEventListener(MouseEvent.MOUSE_UP,dropthis);
			stage.addEventListener(MouseEvent.MOUSE_UP,dropthis);
			CheckDuplicate();
		}
		private function CheckDuplicate():void
		{
			for(var i:int=0;i<Col1Array.length;i++)
			{
				if(Col1Array[i].index==dragObj.index)
				{
					Col1Array.splice(i,1);
					break;
				}
			}
			for(i=0;i<Col2Array.length;i++)
			{
				if(Col2Array[i].index==dragObj.index)
				{
					Col2Array.splice(i,1);
					break;
				}
			}
		}
		private function dropthis(e:MouseEvent):void
		{
			if(dragObj)
			{
				dragObj.removeEventListener(MouseEvent.MOUSE_UP,dropthis);
				stage.removeEventListener(MouseEvent.MOUSE_UP,dropthis);
				dragObj.stopDrag();
				var fr=getChildByName("Frame");
				var ltop=getChildByName("Line_0");
				var lrgt=getChildByName("Line_1");
				var lbtm=getChildByName("Line_2");
				var LeftX:Number=(fr.x+fr.width)/2-(fr.x+fr.width)/5;
				var LeftY:Number=lbtm.y-(dragObj.height);
				
				var RightX:Number=(fr.x+fr.width)/2+(fr.x+fr.width)/4-dragObj.width;
				var RightY:Number=lbtm.y-(dragObj.height);
				if(dragObj.x>fr.x && dragObj.y>ltop.y && dragObj.x<lrgt.x && dragObj.y<lbtm.y && LeftY>ltop.y && Col1Array.length < (noOfBoxes*2))
				{
					Col1Array.push(dragObj);
				}
				else if(dragObj.x>lrgt.x && dragObj.y>ltop.y && dragObj.x<(fr.x+fr.width) && dragObj.y<lbtm.y && Col2Array.length < (noOfBoxes*2))
				{
					Col2Array.push(dragObj);
				}else
				{
					removeChild(dragObj);
				}
				ArrangeItems(Col1Array,LeftX - dragObj.width,LeftY);
				ArrangeItems(Col2Array,RightX,RightY);
			}
			
		}
		private function ArrangeItems(arr:Array,xpos:Number,ypos:Number):void
		{
			
			var StartX:Number=xpos;
			var StartY:Number=ypos;
			for(var i:int=0;i<arr.length;i++)
			{
				if(arr[i].y>80){
					arr[i].x=StartX;
					arr[i].y=StartY;
					StartY-=arr[i].height;
					if(i == noOfBoxes - 1){
						StartX = xpos + arr[i].width*2;
						StartY = ypos;
					}
				}
			}
			
		}
		private function AddBGFrame():void
		{
			var sh:Shape=new Shape();
			sh.name="Frame";
			sh.graphics.lineStyle(XMLObj.Frame.@borderthickness,XMLObj.Frame.@bordercolor,1);
			sh.graphics.beginFill(XMLObj.Frame.@fillcolor);
			sh.graphics.drawRect(0,0,XMLObj.Frame.@width,XMLObj.Frame.@height);
			sh.graphics.endFill();
			sh.x=XMLObj.Frame.@xpos;
			sh.y=XMLObj.Frame.@ypos;
			addChild(sh);
		}
		private function DrawLines():void
		{
			var NumLines:Number=XMLObj.Lines.Line.length();
			for(var i:int=0;i<NumLines;i++)
			{
				var mc:MovieClip=new MovieClip();
				var Line:Shape=new Shape();
				mc.name="Line_"+i;
				Line.graphics.lineStyle(XMLObj.Lines.Line[i].@borderthickness,XMLObj.Lines.Line[i].@color,1);
				Line.graphics.moveTo(0,0)
				Line.graphics.lineTo(XMLObj.Lines.Line[i].@distancex,XMLObj.Lines.Line[i].@distancey)
				mc.addChild(Line);
				mc.x=XMLObj.Lines.Line[i].@xpos;
				mc.y=XMLObj.Lines.Line[i].@ypos;
				addChild(mc);
			}		
		}
		private function CreateText():void
		{
			var Len=XMLObj.Text.Text.length();
			for(var i:int=0;i<Len;i++)
			{
				AddText(i,TextFieldType.DYNAMIC);
			}
		}
		private function AddInputText():void
		{
			var bool:Boolean=false;
			var TxtFld:TextField=new TextField();
			TxtFld.type=TextFieldType.INPUT;
			TxtFld.selectable=true;
			
			(XMLObj.Input.@multiline=="true")?bool=true:bool=false;
			TxtFld.multiline=bool;	
			TxtFld.wordWrap=bool;	
			
			(XMLObj.Input.@border=="true")?bool=true:bool=false;
			TxtFld.border=bool;
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Text.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Input.@FontSize;
			TF.color=XMLObj.Text.@FontColor;
			TF.align=TextFormatAlign.CENTER;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			TxtFld.maxChars=Number(XMLObj.Input.@maxchars);			
			
			TxtFld.x=Number(XMLObj.Input.@xpos);
			TxtFld.y=Number(XMLObj.Input.@ypos);
			TxtFld.width=Number(XMLObj.Input.@width);
			TxtFld.height=Number(XMLObj.Input.@height);
			
			addChild(TxtFld);
		}
		private function AddText(CurrentIndex:Number,type:String):void
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt"+CurrentIndex;
			TxtFld.autoSize="left";
			TxtFld.selectable=false;
			TxtFld.multiline=false;
			TxtFld.type=type;
			
			
			TxtFld.htmlText=XMLObj.Text.Text[CurrentIndex];
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Text.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Text.@FontSize;
			TF.color=XMLObj.Text.@FontColor;

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			
			TxtFld.x=Number(XMLObj.Text.Text[CurrentIndex].@xpos);
			TxtFld.y=Number(XMLObj.Text.Text[CurrentIndex].@ypos);
			
			addChild(TxtFld);
		}
		private function CreateDraggableItem():MovieClip
		{
			var mc:MovieClip=new MovieClip();
			var sh:Shape=new Shape();
			sh.graphics.lineStyle(XMLObj.Drag.@borderthickness,XMLObj.Drag.@bordercolor,1);
			sh.graphics.beginFill(XMLObj.Drag.@fillcolor);
			sh.graphics.drawRect(0,0,XMLObj.Drag.@width,XMLObj.Drag.@height);
			sh.graphics.endFill();
			mc.addChild(sh);
			mc.x=XMLObj.Drag.@xpos;
			mc.y=XMLObj.Drag.@ypos;
			mc.index=counter;
			counter++;
			mc.mouseChildren=false;
			mc.buttonMode=true;
			return mc;
		}
	}
}